#include <cstdio>
#include <map>
#include <cmath>
#include <string>
#include <vector>
#include <deque>

using namespace std;

//const double EPS = 1e-0;

map <string, int> cur;
deque <pair<int, double> > rate[210]; 
char c[10];

bool h[210];
int hladam;

bool chod(int ic, double kolko) {
	if (ic==hladam) {
		return kolko>1.0;		
	}
	if (h[ic]) {
		return false;
	}
	h[ic]=true;
//	printf("chod %d %lf\n",ic, kolko);

	for (int i=0;i<rate[ic].size();i++) {
    if (chod(rate[ic][i].first, kolko*rate[ic][i].second)) return true;
	}
	return false;
}

int main() {
	int C,R;


	while (true) {
		scanf("%d",&C);
		if (C==0) return 0;

		cur.clear();

		for (int i=0;i<C;i++) {
			scanf(" %s ",c);
			string str(c);
			cur.insert(make_pair(str, i));
			rate[i].clear();
			//printf("y%sy\n",str.c_str());
		}

		scanf("%d",&R);
		for (int i=0;i<R;i++) {
			scanf(" %s ",c);
			string str(c);
			int ifrom=cur[str];
//			printf("x%sx\n",str.c_str());
			scanf(" %s ",c);
			string str2(c);
			int ito=cur[str2];
	//		printf("x%sx\n",str2.c_str());

			int a,b;
			scanf("%d:%d",&a,&b);
			double x=((double)b)/a;
			rate[ifrom].push_back(make_pair(ito, x));
		}

		/*for (int i=0;i<C;i++) {
			for (int j=0;j<rate[i].size();j++)
			printf("%d %d %lf\n",i,rate[i][j].first,rate[i][j].second);
		}*/

		bool found=false;
		for (int i=0;i<C && !found;i++) {
			for (int j=0;j<C;j++) h[j]=false;
			hladam = i;
			//found = chod(i,1.0);
			
			for (int k=0;k<rate[i].size() && !found;k++) {
				if (chod(rate[i][k].first, rate[i][k].second)) found=true;
			}
		}
		
		if (found) 
			printf("Arbitrage\n");
		else
			printf("Ok\n");
		
	}

	return 0;
}
