#include <cstdio>
#include <map>
#include <cmath>
#include <string>
#include <vector>
#include <deque>

using namespace std;

const double EPS = 1e-50;

map <string, int> cur;
deque <pair<int, pair<int, int> > > rate[210]; 
char c[10];

pair <int, int>  h[210];

bool chod(int ic, double kolko) {
	if (fabs(h[ic])>EPS) {
		if (h[ic]<kolko+EPS) return true;
		else return false;
	}
	h[ic]=kolko;
	//printf("chod %d %lf\n",ic, kolko);

	for (int i=0;i<rate[ic].size();i++) {
    if (chod(rate[ic][i].first, kolko*rate[ic][i].second)) return true;
	}
	return false;
}

int main() {
	int C,R;


	while (true) {
		scanf("%d",&C);
		if (C==0) return 0;

		cur.clear();

		for (int i=0;i<C;i++) {
			scanf(" %s ",c);
			string str(c);
			cur.insert(make_pair(str, i));
			rate[i].clear();
			//printf("y%sy\n",str.c_str());
		}

		scanf("%d",&R);
		for (int i=0;i<R;i++) {
			scanf(" %s ",c);
			string str(c);
			int ifrom=cur[str];
//			printf("x%sx\n",str.c_str());
			scanf(" %s ",c);
			string str2(c);
			int ito=cur[str2];
	//		printf("x%sx\n",str2.c_str());

			int a,b;
			scanf("%d:%d",&a,&b);
			rate[ifrom].push_back(make_pair(ito, make_pair(a,b)));
		}

		/*for (int i=0;i<C;i++) {
			for (int j=0;j<rate[i].size();j++)
			printf("%d %d %lf\n",i,rate[i][j].first,rate[i][j].second);
		}*/

		bool found=false;
		for (int i=0;i<C && !found;i++) {
			for (int j=0;j<C;j++) {
				h[j].first=0;
				h[j].second=0;
			}
			found = chod(i,);
		}
		
		if (found) 
			printf("Arbitrage\n");
		else
			printf("Ok\n");
		
	}

	return 0;
}
